#include <stdio.h>

#ifdef DEBUG
#include <google/gflags.h>
DECLARE_int32(verbose);
#define LOG(msg, ...) do {                                              \
        fprintf(stderr, "%s:%d: " msg,  __FILE__, __LINE__, ## __VA_ARGS__); \
        fflush(stderr);                                                 \
    } while (0)
#define LOG2(msg, ...) do {                                             \
    if (FLAGS_verbose) {                                                \
        fprintf(stderr, "%s:%d: " msg,  __FILE__, __LINE__, ## __VA_ARGS__); \
        fflush(stderr);                                                 \
    }                                                                   \
    } while (0)
#else
#define LOG(msg, ...) do {} while (0)
#define LOG2(msg, ...) do {} while (0)
#endif

#define CHECK(b) do {                                   \
        if (!(b)) {                                     \
            LOG("failed (%s)\n", __STRING(b));          \
            exit(1);                                    \
        }                                               \
    } while (0)

#define CHECKL(b, msg, ...) do {                                        \
        if (!(b)) {                                                     \
            LOG("failed (%s): " msg, __STRING(b), ## __VA_ARGS__);      \
            exit(1);                                                    \
        }                                                               \
    } while (0)
