#ifndef _GNU_SOURCE
# define _GNU_SOURCE
#endif

#include "log.h"
#include "rover.h"
#include "parser.h"
#include "visualizer.h"

#include <stdlib.h>
#include <fenv.h>

#include <google/gflags.h>

extern bool done;
extern bool come_tel;

int main(int argc, char* argv[]) {
#ifdef DEBUG
    int excepts = fegetexcept();
    excepts |= FE_INVALID | FE_DIVBYZERO | FE_OVERFLOW;
    //excepts |= FE_INVALID;
    feenableexcept(excepts);
#endif

    google::ParseCommandLineFlags(&argc, &argv, true);

    const char* host = "localhost";
    const char* port = "9999";
    if (argc >= 2) {
        host = argv[1];
        if (argc >= 3) {
            CHECKL(argc == 3, "%s host port\n", argv[0]);
            port = argv[2];
        }
    }

    NetStream stream(host, port);
    Rover rover(&stream);
    Visual vis(&rover);
    while (!done) {
        rover.proc();
        parse(&stream, &rover);

        if (come_tel) vis.draw();
    }
}
