/**
 * $Id$
 *
 * Copyright (C) shinichiro.h <hamaji@nii.ac.jp>
 *  http://shinh.skr.jp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef parser_h_
#define parser_h_

#include <string>

using namespace std;

class Rover;

class Stream {
public:
    int getchar();
    void send(const string& msg);

    bool readable();

    int readFd;
    int writeFd;
};

class NetStream : public Stream {
public:
    NetStream(const char* host, const char* port);
};

void parse_line(Stream* stream, Rover* rover);
void parse(Stream* stream, Rover* rover);

#endif // ! parser_h_
