#include <set>
#include <vector>
#include <utility>

using namespace std;

class Obj;
class Rover;
class HalfLine;

struct WO {
    float x, y, r;
    char type;
    int id;
    int clusterId;
};

class World {
public:
    explicit World(Rover* rover);

    void addObject(const Obj* o);

    void calcPath(float x, float y, float curDir);

    void showClusters();

    bool updated() const { return added; }

    void reset();

    void chooseCluster(float x, float y, const HalfLine& hl,
                       int* minClusterOut, float* minDistance,
                       int ignore_cluster = -1);

    bool needBrake(float x, float y, float speed) const;

    vector<WO*> wos;
    vector<vector<WO*> > cluster;
    set<pair<pair<pair<float, float>, float>, int> > checker;
    bool added;

    float gx, gy;
    float gx2, gy2;
    int prev_cluster;

    Rover* rover;

    const WO* goal_reason;
};
